Index: channels/chan_zap.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_zap.c,v
retrieving revision 1.360
diff -u -r1.360 chan_zap.c
--- channels/chan_zap.c	17 Oct 2004 05:05:22 -0000	1.360
+++ channels/chan_zap.c	23 Oct 2004 22:38:45 -0000
@@ -152,6 +152,8 @@
 
 #define DCHAN_AVAILABLE	(DCHAN_PROVISIONED | DCHAN_NOTINALARM | DCHAN_UP)
 
+#define zt_close(fd) if(fd > 0) close(fd);
+
 static char context[AST_MAX_EXTENSION] = "default";
 static char cid_num[256] = "";
 static char cid_name[256] = "";
@@ -765,7 +767,7 @@
 	if (chan) {
 		if (ioctl(fd, ZT_SPECIFY, &chan)) {
 			x = errno;
-			close(fd);
+			zt_close(fd);
 			errno = x;
 			ast_log(LOG_WARNING, "Unable to specify channel %d: %s\n", chan, strerror(errno));
 			return -1;
@@ -776,11 +778,6 @@
 	return fd;
 }
 
-static void zt_close(int fd)
-{
-	close(fd);
-}
-
 int zt_setlinear(int zfd, int linear)
 {
 	int res;
@@ -6072,7 +6069,7 @@
 		x = channels[y];
 		if (ioctl(fd, ZT_SPECIFY, &x)) {
 			ast_log(LOG_WARNING, "Failed to specify channel %d: %s\n", channels[y], strerror(errno));
-			close(fd);
+			zt_close(fd);
 			return -1;
 		}
 		if (ioctl(fd, ZT_GET_PARAMS, &p)) {
@@ -6081,18 +6078,18 @@
 		}
 		if (ioctl(fd, ZT_SPANSTAT, &si)) {
 			ast_log(LOG_WARNING, "Failed go get span information on channel %d (span %d)\n", channels[y], p.spanno);
-			close(fd);
+			zt_close(fd);
 			return -1;
 		}
 		span = p.spanno - 1;
 		if (pris[span].trunkgroup) {
 			ast_log(LOG_WARNING, "Span %d is already provisioned for trunk group %d\n", span + 1, pris[span].trunkgroup);
-			close(fd);
+			zt_close(fd);
 			return -1;
 		}
 		if (pris[span].pvts[0]) {
 			ast_log(LOG_WARNING, "Span %d is already provisioned with channels (implicit PRI maybe?)\n", span + 1);
-			close(fd);
+			zt_close(fd);
 			return -1;
 		}
 		if (!y) {
@@ -6103,7 +6100,7 @@
 		pris[ospan].dchannels[y] = channels[y];
 		pris[ospan].dchanavail[y] |= DCHAN_PROVISIONED;
 		pris[span].span = span + 1;
-		close(fd);
+		zt_close(fd);
 	}
 	return 0;	
 }
@@ -7047,7 +7044,7 @@
 			else {
 				/* Looks good.  Drop the pseudo channel now, clear up the assignment, and
 				   wakeup the potential sleeper */
-				close(crv->subs[SUB_REAL].zfd);
+				zt_close(crv->subs[SUB_REAL].zfd);
 				pri->pvts[principle]->call = crv->call;
 				pri_assign_bearer(crv, pri, pri->pvts[principle]);
 				ast_log(LOG_DEBUG, "Assigning bearer %d/%d to CRV %d:%d\n",
@@ -8051,13 +8048,13 @@
 		}
 		res = ioctl(pri->fds[i], ZT_GET_PARAMS, &p);
 		if (res) {
-			close(pri->fds[i]);
+			zt_close(pri->fds[i]);
 			pri->fds[i] = -1;
 			ast_log(LOG_ERROR, "Unable to get parameters for D-channel %d (%s)\n", x, strerror(errno));
 			return -1;
 		}
 		if (p.sigtype != ZT_SIG_HDLCFCS) {
-			close(pri->fds[i]);
+			zt_close(pri->fds[i]);
 			pri->fds[i] = -1;
 			ast_log(LOG_ERROR, "D-channel %d is not in HDLC/FCS mode.  See /etc/zaptel.conf\n", x);
 			return -1;
@@ -8065,7 +8062,7 @@
 		memset(&si, 0, sizeof(si));
 		res = ioctl(pri->fds[i], ZT_SPANSTAT, &si);
 		if (res) {
-			close(pri->fds[i]);
+			zt_close(pri->fds[i]);
 			pri->fds[i] = -1;
 			ast_log(LOG_ERROR, "Unable to get span state for D-channel %d (%s)\n", x, strerror(errno));
 		}
@@ -8079,7 +8076,7 @@
 		bi.bufsize = 1024;
 		if (ioctl(pri->fds[i], ZT_SET_BUFINFO, &bi)) {
 			ast_log(LOG_ERROR, "Unable to set appropriate buffering on channel %d\n", x);
-			close(pri->fds[i]);
+			zt_close(pri->fds[i]);
 			pri->fds[i] = -1;
 			return -1;
 		}
@@ -8092,7 +8089,7 @@
 		if (i)
 			pri_enslave(pri->dchans[0], pri->dchans[i]);
 		if (!pri->dchans[i]) {
-			close(pri->fds[i]);
+			zt_close(pri->fds[i]);
 			pri->fds[i] = -1;
 			ast_log(LOG_ERROR, "Unable to create PRI structure\n");
 			return -1;
@@ -8113,7 +8110,7 @@
 		for (i=0;i<NUM_DCHANS;i++) {
 			if (!pri->dchannels[i])
 				break;
-			close(pri->fds[i]);
+			zt_close(pri->fds[i]);
 			pri->fds[i] = -1;
 		}
 		ast_log(LOG_ERROR, "Unable to spawn D-channel: %s\n", strerror(errno));
